/* Displays directional arrrow reported by an Arduino Serial output  
   based on serial terminal feedback in angle format (0-360 degrees) 
   as delimited by ":" character.
   
   Prepared by Hans Huth 
   1/6/2020
*/

import processing.serial.*;
Serial port;
String data = "";
PFont font;
int reading;

void setup(){
  size(800,800);
  strokeWeight(8);
  
  //Change "COM9" to the name of the serial port on your computer
  port = new Serial(this, "/dev/cu.Repleo-CH341-0000203A", 9600);
  port.bufferUntil(':'); 
  
  //Change the font name to reflect the name of the font you created
  font = loadFont("AgencyFB-Bold-200.vlw");
  textFont(font, 400);
}

void draw(){
  background(0,0,0);
  stroke(255,255,255);
  drawArrow(400,400,300,reading);
}

void serialEvent (Serial port)
{
  data = port.readString();
  data = data.substring(0, data.length() - 1);
  reading = int(data) + 270;
}

void drawArrow(int cx, int cy, int len, float angle){
  pushMatrix();
  translate(cx, cy);
  rotate(radians(angle));
  line(0,0,len, 0);
  line(len, 0, len - 8, -8);
  line(len, 0, len - 8, 8);
  popMatrix();
}
